Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2232)
@@ -2553,109 +3051,112 @@
 
           CASE ( 'c_liq*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   c_liq_av(j,i) = c_liq_av(j,i) + c_liq(j,i)
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                c_liq_av(j,i) = c_liq_av(j,i) + surf_lsm_h%c_liq(m)
+             ENDDO
+
+          CASE ( 'c_soil*' )
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                c_soil_av(j,i) = c_soil_av(j,i) + (1.0 - surf_lsm_h%c_veg(m))
+             ENDDO
+
+          CASE ( 'c_veg*' )
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                c_veg_av(j,i) = c_veg_av(j,i) + surf_lsm_h%c_veg(m)
+             ENDDO
+
+          CASE ( 'ghf_eb*' )
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                ghf_eb_av(j,i) = ghf_eb_av(j,i) + surf_lsm_h%ghf_eb(m)
+             ENDDO
+
+          CASE ( 'lai*' )
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                lai_av(j,i) = lai_av(j,i) + surf_lsm_h%lai(m)
+             ENDDO
+
+          CASE ( 'm_liq_eb*' )
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                m_liq_eb_av(j,i) = m_liq_eb_av(j,i) + m_liq_eb_h%var_1d(m)
+             ENDDO
+
+          CASE ( 'm_soil' )
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                DO  k = nzb_soil, nzt_soil
+                   m_soil_av(k,j,i) = m_soil_av(k,j,i) + m_soil_h%var_2d(k,m)
                 ENDDO
              ENDDO
 
-          CASE ( 'c_soil*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   c_soil_av(j,i) = c_soil_av(j,i) + (1.0 - c_veg(j,i))
-                ENDDO
-             ENDDO
-
-          CASE ( 'c_veg*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   c_veg_av(j,i) = c_veg_av(j,i) + c_veg(j,i)
-                ENDDO
-             ENDDO
-
-          CASE ( 'ghf_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   ghf_eb_av(j,i) = ghf_eb_av(j,i) + ghf_eb(j,i)
-                ENDDO
-             ENDDO
-
-          CASE ( 'lai*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   lai_av(j,i) = lai_av(j,i) + lai(j,i)
-                ENDDO
-             ENDDO
-
-          CASE ( 'm_liq_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   m_liq_eb_av(j,i) = m_liq_eb_av(j,i) + m_liq_eb(j,i)
-                ENDDO
-             ENDDO
-
-          CASE ( 'm_soil' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb_soil, nzt_soil
-                      m_soil_av(k,j,i) = m_soil_av(k,j,i) + m_soil(k,j,i)
-                   ENDDO
-                ENDDO
-             ENDDO
-
           CASE ( 'qsws_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   qsws_eb_av(j,i) = qsws_eb_av(j,i) + qsws_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                qsws_eb_av(j,i) = qsws_eb_av(j,i) + surf_lsm_h%qsws_eb(m)
              ENDDO
 
           CASE ( 'qsws_liq_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   qsws_liq_eb_av(j,i) = qsws_liq_eb_av(j,i) + qsws_liq_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                qsws_liq_eb_av(j,i) = qsws_liq_eb_av(j,i) +                    &
+                                      surf_lsm_h%qsws_liq_eb(m)
              ENDDO
 
           CASE ( 'qsws_soil_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   qsws_soil_eb_av(j,i) = qsws_soil_eb_av(j,i) + qsws_soil_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                qsws_soil_eb_av(j,i) = qsws_soil_eb_av(j,i) +                  &
+                                       surf_lsm_h%qsws_soil_eb(m)
              ENDDO
 
           CASE ( 'qsws_veg_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   qsws_veg_eb_av(j,i) = qsws_veg_eb_av(j,i) + qsws_veg_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                qsws_veg_eb_av(j,i) = qsws_veg_eb_av(j,i) +                    &
+                                      surf_lsm_h%qsws_veg_eb(m)
              ENDDO
 
           CASE ( 'r_a*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   r_a_av(j,i) = r_a_av(j,i) + r_a(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                r_a_av(j,i) = r_a_av(j,i) + surf_lsm_h%r_a(m)
              ENDDO
 
           CASE ( 'r_s*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   r_s_av(j,i) = r_s_av(j,i) + r_s(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                r_s_av(j,i) = r_s_av(j,i) + surf_lsm_h%r_s(m)
              ENDDO
 
           CASE ( 'shf_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   shf_eb_av(j,i) = shf_eb_av(j,i) + shf_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                shf_eb_av(j,i) = shf_eb_av(j,i) + surf_lsm_h%shf_eb(m)
              ENDDO
 
           CASE ( 't_soil' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb_soil, nzt_soil
-                      t_soil_av(k,j,i) = t_soil_av(k,j,i) + t_soil(k,j,i)
-                   ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                DO  k = nzb_soil, nzt_soil
+                   t_soil_av(k,j,i) = t_soil_av(k,j,i) + t_soil_h%var_2d(k,m)
                 ENDDO
              ENDDO
@@ -2671,6 +3172,6 @@
 
           CASE ( 'c_liq*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    c_liq_av(j,i) = c_liq_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2678,6 +3179,6 @@
 
           CASE ( 'c_soil*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    c_soil_av(j,i) = c_soil_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2685,6 +3186,6 @@
 
           CASE ( 'c_veg*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    c_veg_av(j,i) = c_veg_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2692,6 +3193,6 @@
 
           CASE ( 'ghf_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    ghf_eb_av(j,i) = ghf_eb_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2699,6 +3200,6 @@
 
          CASE ( 'lai*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    lai_av(j,i) = lai_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2706,6 +3207,6 @@
 
           CASE ( 'm_liq_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    m_liq_eb_av(j,i) = m_liq_eb_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2713,6 +3214,6 @@
 
           CASE ( 'm_soil' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    DO  k = nzb_soil, nzt_soil
                       m_soil_av(k,j,i) = m_soil_av(k,j,i) / REAL( average_count_3d, KIND=wp )
@@ -2722,6 +3223,6 @@
 
           CASE ( 'qsws_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    qsws_eb_av(j,i) = qsws_eb_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2729,6 +3230,6 @@
 
           CASE ( 'qsws_liq_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    qsws_liq_eb_av(j,i) = qsws_liq_eb_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2736,6 +3237,6 @@
 
           CASE ( 'qsws_soil_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    qsws_soil_eb_av(j,i) = qsws_soil_eb_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2743,6 +3244,6 @@
 
           CASE ( 'qsws_veg_eb*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    qsws_veg_eb_av(j,i) = qsws_veg_eb_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2750,6 +3251,6 @@
 
           CASE ( 'r_a*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    r_a_av(j,i) = r_a_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2757,6 +3258,6 @@
 
           CASE ( 'r_s*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    r_s_av(j,i) = r_s_av(j,i) / REAL( average_count_3d, KIND=wp )
                 ENDDO
@@ -2764,6 +3265,6 @@
 
           CASE ( 't_soil' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
+             DO  i = nxl, nxr
+                DO  j = nys, nyn
                    DO  k = nzb_soil, nzt_soil
                       t_soil_av(k,j,i) = t_soil_av(k,j,i) / REAL( average_count_3d, KIND=wp )
@@ -2771,4 +3272,6 @@
                 ENDDO
              ENDDO
+!
+!-- 
 
        END SELECT
@@ -2837,8 +3340,9 @@
     CHARACTER (LEN=*) ::  variable !< 
 
-    INTEGER(iwp) ::  av !< 
-    INTEGER(iwp) ::  i  !< 
-    INTEGER(iwp) ::  j  !< 
-    INTEGER(iwp) ::  k  !< 
+    INTEGER(iwp) ::  av      !< 
+    INTEGER(iwp) ::  i       !< running index 
+    INTEGER(iwp) ::  j       !< running index
+    INTEGER(iwp) ::  k       !< running index
+    INTEGER(iwp) ::  m       !< running index
     INTEGER(iwp) ::  nzb_do  !< 
     INTEGER(iwp) ::  nzt_do  !< 
@@ -2849,15 +3353,17 @@
     REAL(wp), DIMENSION(nxlg:nxrg,nysg:nyng,nzb:nzt+1) ::  local_pf !< 
 
+
     found = .TRUE.
 
     SELECT CASE ( TRIM( variable ) )
-
-
+!
+!--    Before data is transfered to local_pf, transfer is it 2D dummy variable and exchange ghost points therein. 
+!--    However, at this point this is only required for instantaneous arrays, time-averaged quantities are already exchanged. 
        CASE ( 'c_liq*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = c_liq(j,i) * c_veg(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h%c_liq(m) * surf_lsm_h%c_veg(m)
              ENDDO
           ELSE
@@ -2874,8 +3380,8 @@
        CASE ( 'c_soil*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = 1.0_wp - c_veg(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = 1.0_wp - surf_lsm_h%c_veg(m)
              ENDDO
           ELSE
@@ -2892,8 +3398,8 @@
        CASE ( 'c_veg*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = c_veg(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h%c_veg(m)
              ENDDO
           ELSE
@@ -2910,8 +3416,8 @@
        CASE ( 'ghf_eb*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = ghf_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h%ghf_eb(m)
              ENDDO
           ELSE
@@ -2928,8 +3434,8 @@
        CASE ( 'lai*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = lai(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h%lai(m)
              ENDDO
           ELSE
@@ -2946,8 +3452,8 @@
        CASE ( 'm_liq_eb*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = m_liq_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = m_liq_eb_h%var_1d(m)
              ENDDO
           ELSE
@@ -2964,9 +3470,9 @@
        CASE ( 'm_soil_xy', 'm_soil_xz', 'm_soil_yz' )
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO k = nzb_soil, nzt_soil
-                      local_pf(i,j,k) = m_soil(k,j,i)
-                   ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                DO k = nzb_soil, nzt_soil
+                   local_pf(i,j,k) = m_soil_h%var_2d(k,m)
                 ENDDO
              ENDDO
@@ -2988,8 +3494,8 @@
        CASE ( 'qsws_eb*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) =  qsws_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) =  surf_lsm_h%qsws_eb(m)
              ENDDO
           ELSE
@@ -3006,8 +3512,8 @@
        CASE ( 'qsws_liq_eb*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) =  qsws_liq_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h%qsws_liq_eb(m)
              ENDDO
           ELSE
@@ -3024,8 +3530,8 @@
        CASE ( 'qsws_soil_eb*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) =  qsws_soil_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) =  surf_lsm_h%qsws_soil_eb(m)
              ENDDO
           ELSE
@@ -3042,8 +3548,8 @@
        CASE ( 'qsws_veg_eb*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) =  qsws_veg_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) =  surf_lsm_h%qsws_veg_eb(m)
              ENDDO
           ELSE
@@ -3061,8 +3567,8 @@
        CASE ( 'r_a*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = r_a(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h%r_a(m)
              ENDDO
           ELSE
@@ -3079,8 +3585,8 @@
        CASE ( 'r_s*_xy' )        ! 2d-array
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) = r_s(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) = surf_lsm_h%r_s(m)
              ENDDO
           ELSE
@@ -3097,8 +3603,8 @@
        CASE ( 'shf_eb*_xy' )        ! 2d-array
           IF ( av == 0 ) THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   local_pf(i,j,nzb+1) =  shf_eb(j,i)
-                ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i                   = surf_lsm_h%i(m)            
+                j                   = surf_lsm_h%j(m)
+                local_pf(i,j,nzb+1) =  surf_lsm_h%shf_eb(m)
              ENDDO
           ELSE
@@ -3115,9 +3621,9 @@
        CASE ( 't_soil_xy', 't_soil_xz', 't_soil_yz' )
           IF ( av == 0 )  THEN
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO k = nzb_soil, nzt_soil
-                      local_pf(i,j,k) = t_soil(k,j,i)
-                   ENDDO
+             DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                DO k = nzb_soil, nzt_soil
+                   local_pf(i,j,k) = t_soil_h%var_2d(k,m)
                 ENDDO
              ENDDO
@@ -3168,4 +3674,5 @@
     INTEGER(iwp) ::  j     !< 
     INTEGER(iwp) ::  k     !< 
+    INTEGER(iwp) ::  m     !< running index
 
     LOGICAL      ::  found !< 
@@ -3178,15 +3685,16 @@
 
     SELECT CASE ( TRIM( variable ) )
-
+!
+!--   Requires 3D exchange
 
       CASE ( 'm_soil' )
 
          IF ( av == 0 )  THEN
-            DO  i = nxlg, nxrg
-               DO  j = nysg, nyng
-                  DO  k = nzb_soil, nzt_soil
-                     local_pf(i,j,k) = m_soil(k,j,i)
-                  ENDDO
-               ENDDO
+            DO  m = 1, surf_lsm_h%ns
+                i   = surf_lsm_h%i(m)            
+                j   = surf_lsm_h%j(m)
+                DO  k = nzb_soil, nzt_soil
+                   local_pf(i,j,k) = m_soil_h%var_2d(k,m)
+                ENDDO
             ENDDO
          ELSE
@@ -3203,9 +3711,9 @@
 
          IF ( av == 0 )  THEN
-            DO  i = nxlg, nxrg
-               DO  j = nysg, nyng
-                  DO  k = nzb_soil, nzt_soil
-                     local_pf(i,j,k) = t_soil(k,j,i)
-                  ENDDO
+            DO  m = 1, surf_lsm_h%ns
+               i   = surf_lsm_h%i(m)            
+               j   = surf_lsm_h%j(m)
+               DO  k = nzb_soil, nzt_soil
+                  local_pf(i,j,k) = t_soil_h%var_2d(k,m)
                ENDDO
             ENDDO
@@ -3261,9 +3769,9 @@
           WRITE ( 14 )  'lai_av              ';  WRITE ( 14 )  lai_av
        ENDIF
-       WRITE ( 14 )  'm_liq_eb            ';  WRITE ( 14 )  m_liq_eb
+       WRITE ( 14 )     'm_liq_eb            ';  WRITE ( 14 )  m_liq_eb_h
        IF ( ALLOCATED( m_liq_eb_av ) )  THEN
           WRITE ( 14 )  'm_liq_eb_av         ';  WRITE ( 14 )  m_liq_eb_av
        ENDIF
-       WRITE ( 14 )  'm_soil              ';  WRITE ( 14 )  m_soil
+       WRITE ( 14 )     'm_soil              ';  WRITE ( 14 )  m_soil_h
        IF ( ALLOCATED( m_soil_av ) )  THEN
           WRITE ( 14 )  'm_soil_av           ';  WRITE ( 14 )  m_soil_av
@@ -3284,5 +3792,5 @@
           WRITE ( 14 )  'shf_eb_av           ';  WRITE ( 14 )  shf_eb_av
        ENDIF
-       WRITE ( 14 )  't_soil              ';  WRITE ( 14 )  t_soil
+       WRITE ( 14 )     't_soil              ';  WRITE ( 14 )  t_soil_h
        IF ( ALLOCATED( t_soil_av ) )  THEN
           WRITE ( 14 )  't_soil_av           ';  WRITE ( 14 )  t_soil_av
@@ -3349,4 +3857,16 @@
           tmp_3d2   !< 
 
+    REAL(wp),                                                                  &
+       DIMENSION(1:surf_lsm_h%ns) ::                                  &
+          tmp_walltype_1d   !< 
+
+    REAL(wp),                                                                  &
+       DIMENSION(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) ::              &
+          tmp_walltype_2d   !< 
+
+    REAL(wp),                                                                  &
+       DIMENSION(nzb_soil:nzt_soil,1:surf_lsm_h%ns) ::                &
+          tmp_walltype_2d2  !< 
+
 
    IF ( initializing_actions == 'read_restart_data' )  THEN
@@ -3366,6 +3886,6 @@
             nync = nynfa(i,k) + offset_ya(i,k)
 
-
             SELECT CASE ( TRIM( field_char ) )
+
 
                 CASE ( 'c_liq_av' )
@@ -3374,5 +3894,5 @@
                    ENDIF
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   c_liq_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                   c_liq_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
                                   tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3382,5 +3902,5 @@
                    ENDIF
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   c_soil_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                   c_soil_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
                                   tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3390,5 +3910,5 @@
                    ENDIF
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   c_veg_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                   c_veg_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
                                   tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3398,11 +3918,11 @@
                    ENDIF
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   ghf_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                   ghf_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =        &
                                   tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 'm_liq_eb' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   m_liq_eb(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =        &
-                                 tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                   IF ( k == 1 )  READ ( 13 )  tmp_walltype_1d !tmp_2d
+                   m_liq_eb_h%var_1d(1:surf_lsm_h%ns)  =                       &
+                                 tmp_walltype_1d(1:surf_lsm_h%ns)
 
                 CASE ( 'lai_av' )
@@ -3411,5 +3931,5 @@
                    ENDIF
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   lai_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = &
+                   lai_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =           &
                                   tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3423,8 +3943,7 @@
 
                 CASE ( 'm_soil' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d2(:,:,:)
-                   m_soil(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
-                          tmp_3d2(nzb_soil:nzt_soil,nysf-nbgp:nynf             &
-                          +nbgp,nxlf-nbgp:nxrf+nbgp)
+                   IF ( k == 1 )  READ ( 13 )  tmp_walltype_2d2(:,:)
+                   m_soil_h%var_2d(:,1:surf_lsm_h%ns) =                        &
+                          tmp_walltype_2d2(:,1:surf_lsm_h%ns)   
 
                 CASE ( 'm_soil_av' )
@@ -3442,5 +3961,5 @@
                    ENDIF  
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qsws_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                   qsws_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =      &
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -3450,5 +3969,5 @@
                    ENDIF  
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   qsws_liq_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                   qsws_liq_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =  &
                                           tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
                 CASE ( 'qsws_soil_eb_av' )
@@ -3473,12 +3992,11 @@
                    ENDIF
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
-                   shf_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                   shf_eb_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  =       &
                          tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
                 CASE ( 't_soil' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   t_soil(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
-                                   tmp_3d(:,nysf-nbgp:nynf+nbgp,               &
-                                                nxlf-nbgp:nxrf+nbgp)
+                   IF ( k == 1 )  READ ( 13 )  tmp_walltype_2d(:,:)
+                   t_soil_h%var_2d(:,1:surf_lsm_h%ns) =                        &
+                         tmp_walltype_2d(:,1:surf_lsm_h%ns)      
 
                 CASE ( 't_soil_av' )
@@ -3488,5 +4006,5 @@
                    IF ( k == 1 )  READ ( 13 )  tmp_3d2(:,:,:)
                    t_soil_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =      &
-                                    tmp_3d(:,nysf-nbgp:nynf+nbgp,             &
+                                    tmp_3d2(:,nysf-nbgp:nynf+nbgp,             &
                                     nxlf-nbgp:nxrf+nbgp)
 
@@ -3525,6 +4043,7 @@
        IMPLICIT NONE
 
-       INTEGER :: i  !< running index
-       INTEGER :: j  !< running index
+       INTEGER(iwp) ::  i       !< running index
+       INTEGER(iwp) ::  j       !< running index
+       INTEGER(iwp) ::  m       !< running index
 
        REAL(wp), PARAMETER :: alpha_ch  = 0.018_wp !< Charnock constant (0.01-0.11). Use 0.01 for FLake and 0.018 for ECMWF
